/*
 * DiscreteScaleStrings.java
 */
package UTEStatsViewer;
import java.util.*;

/**
 * The DiscreteScaleValues object for a scale of strings.
 */
final class DiscreteScaleStrings implements DiscreteScaleValues {
   // The Strings are stored as NamedString values in a Vector.
   private Vector vec = new Vector();


   /** Add an element to this object. */
   void addElement(String string) {
      vec.addElement(new NamedString(string));
   }


   /** Return the value at the given index. */
   String elementAt(int i) {
      return ((NamedString)vec.elementAt(i)).toString();
   }


   // Implement the DiscreteScaleValues interface

   /** Return a string as it is to appear with a scale. */
   public String getDiscreteScaleValue(int i)
         throws ArrayIndexOutOfBoundsException {
      return ((NamedString) vec.elementAt(i)).getName();
   }


   /** Return all task labels as they are to appear in a scale. */
   public String[] getDiscreteScaleValues() {
      int size = vec.size();
      String ret[] = new String[size];

      for (int i = 0; i < size; i++) {
         ret[i] = ((NamedString) vec.elementAt(i)).getName();
      }

      return ret;
   }


   /** Return a task label as it is to appear in messages. */
   public String getDiscreteScaleValueString(int i)
         throws ArrayIndexOutOfBoundsException {
      return ((NamedString) vec.elementAt(i)).getName();
   }


   /** Return all task labels as they are to appear in messages. */
   public String[] getDiscreteScaleValueStrings() {
      int size = vec.size();
      String ret[] = new String[size];

      for (int i = 0; i < size; i++) {
         ret[i] = ((NamedString) vec.elementAt(i)).getName();
      }

      return ret;
   }


   /** Return all task labels as they are to appear in messages. */
   public Named[] getDiscreteScaleValueNamed() {
      int size = vec.size();
      Named ret[] = new Named[size];

      for (int i = 0; i < size; i++) {
         ret[i] = (NamedString) vec.elementAt(i);
      }

      return ret;
   }


   /** Return the number of tasks in this object. */
   public int size() {
      return vec.size();
   }
}
